(*                                                          *)
(*     ASY.PAS (Borland Pascal 7.0)                         *)
(*                                                          *)
(*     ⮩  ନ  1.1                *)
(*     ᪨ ࠢ () ᫠ ७ 1995           *)
(*                                                          *)
(*      ᫥ 䨪樨: 7 ᥭ 1995 .       *)
(*                                                          *)
(*     ᫮ ࠭:                             *)
(*       ணࠬ   ।祭     *)
(*      ணࠬ   ࣠    *)
(*       ࠭    ࢮ砫쭮 ਠ *)
(*     ࠢ    ⠢  ᮡ.         *)
(*       ᯮ짮 楤 ணࠬ  ᢮ *)
(*     楫.                                               *)
(*     ᫨                      *)
(*     e-mail': 2:464/39@FidoNet                          *)
{$R-}
unit Asy;
interface

const
      ReceiveBufferSize : Word = 1024;  {  ਥ  㬮砭}

      pic_EoI    = $20;   { ᨣ 襭 뢠 (EOI)
                                  ஫ 8259}
      pic_Mask   = $21;   { ᪨ 뢠 ஫ 8259}

      SysClockHz = 119000;{ ⥬ ᮢ}
(*
const
      asy_Data   : Word = $3F8;  {  COM1}
      asy_ier    : Word = $3F9;
      asy_mrc    : Word = $3FC;  { ࠢ }
      asy_sts    : Word = $3FD;

      asy_int    = $0C;   { 뢠 COM1, COM3}
      int_mask   = $10;   {᪠ IRQ4  ஫ 8259}

const
      asy_Data   : Word = $2F8;  {  COM2}
      asy_ier    : Word = $2F9;
      asy_mrc    : Word = $2FC;  { ࠢ }
      asy_sts    : Word = $2FD;

      asy_int    = $0B;   { 뢠 COM2, COM4}
      int_mask   = $08;   {᪠ IRQ3  ஫ 8259}

const
      asy_Data   : Word = $3E8;  {  COM3}
      asy_ier    : Word = $3E9;
      asy_mrc    : Word = $3EC;  { ࠢ }
      asy_sts    : Word = $3ED;

const
      asy_Data   : Word = $2E8;  {  COM4}
      asy_ier    : Word = $2E9;
      asy_mrc    : Word = $2EC;  { ࠢ }
      asy_sts    : Word = $2ED;

*)

{Default}
const
      asy_data   : Word = $2E8;  {  COM4}
      asy_ier    : Word = $2E9;
      asy_mrc    : Word = $2EC;  { ࠢ }
      asy_sts    : Word = $2ED;

      asy_int    = $0B;   { 뢠 COM2, COM4}
      int_mask   = $08;   {᪠ IRQ3  ஫ 8259}

procedure Initilize(Port : Byte; Baud : LongInt);    {樠}

procedure asy_Initilize;{樠 ᪮ }

function getBufStatus : Boolean;{᫨   室 ⠭
                                 ᨬ 頥 True}

function  asy_in : Char;{祭 ᨬ  
                         ᫥⥫쭮 }

procedure asy_out(stOut : Char);{ ᨬ 
                                 ᫥⥫ }
procedure Done;{樠}

implementation

uses
     AllocBuf;

var
     rbuf_in     : Word;          {⥫    ਥ}
     rbuf_out    : Word;          {⥫  墮  ਥ}
     asy_rbuf    : Pointer;       {  ਥ}

     OldVec      : Pointer;       { ண ࠡ稪 IRQ}

     Divisor     : Word;          {⥫ ᪮ }

type
    TWord = record
      Lo, Hi : Byte
    end;


const EnableFlag : Boolean = False;

procedure asy_enb;forward;

procedure Initilize(Port : Byte; Baud : LongInt);

begin

  if EnableFlag then Exit;

  case Port of
   1 : asy_data := MemW[Seg0040:0];
   2 : asy_data := MemW[Seg0040:2];
   3 : asy_data := MemW[Seg0040:4];
   4 : asy_data := MemW[Seg0040:6];
  end;

  asy_ier  := asy_data + 1;
  asy_mrc  := asy_data + 4;
  asy_sts  := asy_data + 5;

  Divisor  := SysClockHz div Baud;

  rbuf_in  := 0;
  rbuf_out := 0;
  asy_rbuf := BufAlloc(ReceiveBufferSize,ReceiveBufferSize);

  asy_enb;

  EnableFlag := True;

  asy_Initilize;
end;

function getBufStatus : Boolean;assembler;
{᫨   室 ⠭
ᨬ 頥 True}

asm
     MOV   AX, rbuf_in
     CMP   AX, rbuf_out
     JZ    @Fls
     MOV   AL, True
     JMP   @Exit
@Fls:
     MOV   AL, False
@Exit:
end;

procedure asy_intup(Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP: Word);
                  interrupt;assembler; {ணࠬ 㦨
                                        뢠 ᫥⥫쭮
                                        }
asm
   CLI                             ; 뢠  ࠡ
                                   ; 㪠⥫ﬨ
   MOV  DX, asy_data               {DX =   }
   IN   AL, DX                     ;  ᨬ
   MOV  BX, rbuf_in                ; 㪠⥫  

   LES  DI, asy_rbuf
   MOV  ES:[DI+BX], AL             ;࠭  ᨬ

   INC  BX                         ;६ 㪠⥫
   CMP  BX, ReceiveBufferSize      ;६ ३  ᫥ ப{?}
   JNE  @asy_int1                  {, ३}
   XOR  BX, BX                     {,  㪠⥫}

@asy_int1:                         ;࠭  㪠⥫
   MOV    rbuf_in, BX

   STI                             ; 뢠

   MOV  AL, 20h                    ;᫠  襭 뢠
                                   {(EOI)  ஫ 8259}
   OUT  pic_EoI, AL

end;
procedure asy_Initilize;assembler;
asm

   CMP EnableFlag, True            ;஢ઠ ⠭ 䫠 {EnableFlag}
   JNE @Exit                       ;᫨    室

   ;樠 ॣ ᪮ 
   MOV DX, asy_data
   ADD DX, 3                       ;뢠  ॣ ஫ 
   MOV AL, 10000000B               ;⠭  {7}
   OUT DX, AL                      ;뫠 

   DEC DX                          ;뢠  訩 ⥫
   DEC DX                          ;᪮ 

   MOV AL, TWord.Hi(Divisor)       ;訩  ⥫
   OUT DX, AL                      ;뫠 訩 

   DEC DX                          ;뢠  訩 
   MOV AL, TWord.Lo(Divisor)       ;訩  ⥫
   OUT DX, AL                      ;뫠 訩 

   ;樠 ॣ ஫ 
   MOV AL, 0                       ;塞 {AL}
   OR  AL,    11B                  ;  {8} 
   OR  AL,   000B                  ;{1 ⮯-}
   OR  AL,  0000B                  ;{   ⭮}
   OR  AL, 00000B                  ;⭠ ⭮
   ADD DX, 3
   OUT DX, AL                      ;
@Exit:
end;
procedure asy_enb;assembler;       {墠  뢠
                                   ᫥⥫쭮  
                                   ࠧ襭 뢠}
asm

                                   ;࠭  室
                                   ;ࠡ稪 뢠 {...}
   MOV  AX, 3500H+asy_int          ;㭪 {35H =}  
   INT  21H                        ;室  {MS-DOS}
   MOV  WORD PTR OldVec+2, ES
   MOV  WORD PTR OldVec,   BX
                                   {⠭ 襣 ࠡ稪 ...}
   PUSH DS                         ;࠭  ᥣ 
   MOV  AX, SEG asy_intup          ;{⠭ DS:DX = }
   MOV  DS, AX                     ;襣 ࠡ稪 뢠
   MOV  DX, OFFSET asy_intup
   MOV  AX, 2500H+asy_int          {㭪 25H = ⠭ }
   INT  21H                        {室  MS-DOS}
   POP  DS                         ;⠭ ᥣ 

   MOV  DX, asy_mrc                ;⠭ ॣ ࠢ 
   MOV  AL, 0BH                    { DTR  OUT2}
   OUT  DX, AL

   MOV  DX, asy_ier                ;⠭ ॣ ࠧ襭
   MOV  AL, 1                      ;뢠 ஫
   OUT  DX, AL                     ;᫥⥫쭮 
   IN   AL, pic_mask               { ⥪  ஫ 8259}
   AND  AL, NOT int_mask           {⠭   COM}
   OUT  pic_mask, AL               {   ஫ 8259}

end;

procedure asy_dsb;assembler;       { 뢠  ᢮
                                     뢠}
asm
   CMP EnableFlag, True            ;஢ઠ ⠭ 䫠 {EnableFlag}
   JNE @Exit                       ;᫨    室

   IN   AL, pic_mask               { ⥪  ஫ 8259}
   OR   AL, int_mask               {   COM}
   OUT  pic_mask, AL               {   ஫ 8259}

   PUSH DS                         ;࠭  ᥣ 
   LDS  DX, OldVec                 ;㧨  室
                                   ;ࠡ稪 뢠
   MOV  AX, 2500H+asy_int          {㭪 25H = ⠭ }
   INT  21H                        {室  MS-DOS}
   POP  DS                         ;⠭ ᥣ 

@Exit:
end;

function  asy_in : Char;assembler;{祭 ᨬ  
                                   ᫥⥫쭮 }
asm

   CMP EnableFlag, True            ;஢ઠ ⠭ 䫠 {EnableFlag}
   JNE @Exit                       ;᫨    室

   PUSH BX                         ;࠭ ॣ {BX}

@asy_in1:                          ;᫨ ᨬ    ਥ
   MOV   BX, rbuf_out              ;ᨬ
   CMP   BX, rbuf_in
   JE    @asy_in1                  ;室 ᨬ  

   PUSH  DI
   PUSH  ES
   LES   DI, asy_rbuf
   MOV   AL, ES:[DI+BX]            ; ⮢
   POP   ES                        ;   
   POP   DI

   INC   BX                        ; 㪠⥫ 
   CMP   BX, ReceiveBufferSize
   JNE   @asy_in2
   XOR   BX, BX                    ; 㪠⥫{,} ᫨  

@asy_in2:
   MOV   rbuf_out, BX              ;  㪠⥫
   POP   BX                        ;⠭ {BX}

@Exit:
end;

procedure asy_out(stOut : Char);assembler;{ ᨬ 
                                          ᫥⥫ }
asm
   CMP EnableFlag, True            ;஢ઠ ⠭ 䫠 {EnableFlag}
   JNE @Exit                       ;᫨    室

   PUSH  DX                        ;࠭ ॣ {DX}

   MOV   DX, asy_sts               ;{DX =   ﭨ}

@asy_out1:                         ;஢{,}    ।
   IN    AL, DX                    ;{ TBE = ⠭}
   AND   AL, 20H
   JZ    @asy_out1                 ;{,}  

   MOV   DX, asy_data              ;{DX =   }
   MOV   AL, stOut
   OUT   DX, AL

   POP   DX                        ;⠭ {DX}

@Exit:
end;

procedure Done;
begin
  asy_dsb;
  FreeMem(asy_rbuf,ReceiveBufferSize);
end;

end.

